/* [cmd_pim.c] Parser table for 'cmd'  */



#include "prs.h"

#include "prs_imp.h"


static string cmd_SNames[] = {
  "Parenthesis", "Comment", "Ide", "Int", "Flo", 
  "Opr", "Set", "Seq", "Pth", "Doc", 
  "Dol", "Program", "Arguments", "Options", "Environment", 
  ":", "=", "true", "false", "<", 
  ">", ";", "$", "/", ".", 
  "..", "_", "flag", "int", "real", 
  "string", "name", "path", "Source", "Dfns", 
  "Dfn", "OptVal", "OptDoc", "Val", "PLst1", 
  "PLst0", "Path", "Root1", "Root2", "RelPa0", 
  "RelP1", "RelP0", "OptDrv", "Pid", "Fid1", 
  "Fid0", "Typ"
};

static int cmd_StartIds[] = {
  33
};

static int cmd_TokKind[] = {
  1, 4, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2
};

static int cmd_NtClass[] = {
  0, 1, 2, 3, 4, 5, 7, 7, 
  8, 8, 8, 13, 13, 13, 14, 15, 
  17, 17, 18
};

static bool cmd_ErrorNt[] = {
  1, 1, 1, 1, 1, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0
};

static KFGHEAD cmd_KfgHead = {
  "cmd",
  33, 19, cmd_SNames,
  1, cmd_StartIds,
  cmd_TokKind,
  cmd_NtClass,
  cmd_ErrorNt
};

static int cmd_PSymbols[] = {
  11, 49, 10, 9, 12, 34, 37, 13, 
  34, 37, 14, 34, 37,
  35, 34,
  2, 15, 51, 36, 10,
  16, 38,
  9,
  17,
  18,
  3,
  4,
  7,
  2,
  19, 39, 20,
  41, 40,
  21, 41, 40,
  42,
  43,
  45,
  22, 2, 23, 45,
  47, 23, 44,
  47, 23, 45,
  48, 46,
  23, 48, 46,
  2, 15,
  24,
  25,
  49,
  49, 24, 2,
  2, 50,
  26, 2, 50,
  27,
  28,
  29,
  30,
  31,
  32,
  33
};

static int cmd_PSymFrms[] = {
  0, 10, 15, 19, 0, 14, 19, 0, 
  14, 19, 0, 14, 19,
  0, 4,
  0, 4, 8, 12, 19,
  0, 4,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0, 4, 10,
  0, 5,
  0, 4, 9,
  0,
  0,
  0,
  0, 4, 8, 12,
  0, 7, 11,
  0, 7, 11,
  0, 4,
  0, 4, 8,
  0, 4,
  0,
  0,
  0,
  0, 5, 9,
  0, 4,
  0, 4, 8,
  0,
  0,
  0,
  0,
  0,
  0,
  0
};

static KFGPROD cmd_KfgProds[] = {
  { "root", 0, 33, 13, &cmd_PSymbols[0], &cmd_PSymFrms[0] },
  { "nil", 0, 34, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 34, 2, &cmd_PSymbols[13], &cmd_PSymFrms[13] },
  { "defn", 0, 35, 5, &cmd_PSymbols[15], &cmd_PSymFrms[15] },
  { "non", 0, 36, 0, (int*)NULL, (int*)NULL },
  { "val", 0, 36, 2, &cmd_PSymbols[20], &cmd_PSymFrms[20] },
  { "non", 0, 37, 0, (int*)NULL, (int*)NULL },
  { "doc", 0, 37, 1, &cmd_PSymbols[22], &cmd_PSymFrms[22] },
  { "true", 0, 38, 1, &cmd_PSymbols[23], &cmd_PSymFrms[23] },
  { "false", 0, 38, 1, &cmd_PSymbols[24], &cmd_PSymFrms[24] },
  { "int", 0, 38, 1, &cmd_PSymbols[25], &cmd_PSymFrms[25] },
  { "real", 0, 38, 1, &cmd_PSymbols[26], &cmd_PSymFrms[26] },
  { "str", 0, 38, 1, &cmd_PSymbols[27], &cmd_PSymFrms[27] },
  { "name", 0, 38, 1, &cmd_PSymbols[28], &cmd_PSymFrms[28] },
  { "path", 0, 38, 3, &cmd_PSymbols[29], &cmd_PSymFrms[29] },
  { "cons", 0, 39, 2, &cmd_PSymbols[32], &cmd_PSymFrms[32] },
  { "nil", 0, 40, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 40, 3, &cmd_PSymbols[34], &cmd_PSymFrms[34] },
  { "ign1", 0, 41, 1, &cmd_PSymbols[37], &cmd_PSymFrms[37] },
  { "ign2", 0, 41, 1, &cmd_PSymbols[38], &cmd_PSymFrms[38] },
  { "rel", 0, 41, 1, &cmd_PSymbols[39], &cmd_PSymFrms[39] },
  { "env", 0, 41, 4, &cmd_PSymbols[40], &cmd_PSymFrms[40] },
  { "abs", 0, 42, 3, &cmd_PSymbols[44], &cmd_PSymFrms[44] },
  { "abs", 0, 43, 3, &cmd_PSymbols[47], &cmd_PSymFrms[47] },
  { "nil", 0, 44, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 45, 2, &cmd_PSymbols[50], &cmd_PSymFrms[50] },
  { "nil", 0, 46, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 46, 3, &cmd_PSymbols[52], &cmd_PSymFrms[52] },
  { "non", 0, 47, 0, (int*)NULL, (int*)NULL },
  { "drive", 0, 47, 2, &cmd_PSymbols[55], &cmd_PSymFrms[55] },
  { "curr", 0, 48, 1, &cmd_PSymbols[57], &cmd_PSymFrms[57] },
  { "prev", 0, 48, 1, &cmd_PSymbols[58], &cmd_PSymFrms[58] },
  { "name", 0, 48, 1, &cmd_PSymbols[59], &cmd_PSymFrms[59] },
  { "ext", 0, 48, 3, &cmd_PSymbols[60], &cmd_PSymFrms[60] },
  { "cons", 0, 49, 2, &cmd_PSymbols[63], &cmd_PSymFrms[63] },
  { "nil", 0, 50, 0, (int*)NULL, (int*)NULL },
  { "cons", 0, 50, 3, &cmd_PSymbols[65], &cmd_PSymFrms[65] },
  { "flag", 0, 51, 1, &cmd_PSymbols[68], &cmd_PSymFrms[68] },
  { "int", 0, 51, 1, &cmd_PSymbols[69], &cmd_PSymFrms[69] },
  { "real", 0, 51, 1, &cmd_PSymbols[70], &cmd_PSymFrms[70] },
  { "str", 0, 51, 1, &cmd_PSymbols[71], &cmd_PSymFrms[71] },
  { "name", 0, 51, 1, &cmd_PSymbols[72], &cmd_PSymFrms[72] },
  { "path", 0, 51, 1, &cmd_PSymbols[73], &cmd_PSymFrms[73] },
  { "Start_Source", 0, 52, 1, &cmd_PSymbols[74], &cmd_PSymFrms[74] }
};

static int cmd_MstShifts[] = {
  1, 3, -1, 5, 7, 9, -1, 11, 
  5, 13, -1, 15, 17, 19, 15, 26, 
  -1, 33, -1, -1, -1, -1, -1, -1, 
  -1, 35, 15, 43, 51, 19, -1, -1, 
  -1, -1, -1, -1, 56, -1, -1, 61, 
  64, 67, -1, -1, 69, 71, -1, -1, 
  -1, 73, 75, 77, 15, -1, 79, -1, 
  56, -1, 83, 83, -1, 87, 19, 83, 
  71, -1, -1, 75, -1, -1, -1, -1, 
  -1
};

static int cmd_DtlShifts[] = {
  -2, 11, -4, 2, -6, 26, -8, 10, 
  -9, 2, -10, 9, -12, 12, -13, 2, 
  -16, 15, -17, 9, -20, -21, -22, -23, 
  -24, -25, 32, 31, 30, 29, 28, 27, 
  -27, 13, -28, 16, -31, -32, -33, -34, 
  -35, -36, -37, 19, 18, 17, 7, 4, 
  3, 2, -39, 10, -41, -42, -43, -44, 
  25, 24, 22, 2, -53, 14, -6, -54, 
  15, 26, -55, 2, -56, 20, -57, 21, 
  -59, 23, -60, 23, -62, 24, -64, 23, 
  -4, -43, -44, 25, 24, 2, -69, 2
};

static int cmd_GoTos[] = {
  0, 2, 10, 15, 17, 23, 25, 27, 
  31, 35, 38, 41, 43, 50, 54, 57, 
  64, 72, 77
};

static int cmd_GoToDfts[] = {
  76, -1, 87, 12, 92, 15, 103, 27, 
  136, 53, 88, -12, -15, -27, -53, 102, 
  -26, 91, 14, 113, 30, 143, 63, 111, 
  -28, 118, -37, 131, 46, 145, 65, 119, 
  37, 138, 57, 120, -37, -57, 121, -37, 
  -57, 139, -59, 122, 37, 57, 140, 59, 
  144, 64, 134, 51, 146, 68, 123, -37, 
  -57, 124, 37, 57, 59, 64, 141, 60, 
  78, 2, 125, 37, 57, 59, 60, 64, 
  80, 4, 41, 84, 9, 99, -16
};

static int cmd_ActDfts[] = {
  45, 45, 46, 36, 45, 45, 35, 45, 
  36, 45, 37, 2, 45, 7, 2, 45, 
  8, 45, 3, 38, 39, 40, 41, 42, 
  43, 5, 2, 45, 45, 7, 14, 11, 
  12, 13, 9, 10, 29, 6, 4, 45, 
  36, 45, 31, 32, 45, 17, 19, 20, 
  21, 45, 27, 33, 2, 30, 45, 15, 
  29, 16, 25, 45, 26, 45, 7, 45, 
  17, 23, 24, 27, 34, 1, 22, 18, 
  28
};


static PARSETAB cmd_ParseTab = {
  &cmd_KfgHead, 44, cmd_KfgProds,
  {
    73, cmd_MstShifts, 88, cmd_DtlShifts,
    19, cmd_GoTos, 79, cmd_GoToDfts,
    73, cmd_ActDfts, 0, (int*)NULL
  }
};

PLR_Tab PLR_get_cmd()
/* simulates a PLR_getTab */
{
  return( PLR_copyTab(&cmd_ParseTab) );
}
