/* [cprj_lim.c] Scanner table for 'cprj'  */

#include "scn_io.h"

#include "scn_imp.h"

static short StaEdg[20] =
/* first edge per state */
{
    0,  32,  33,  34,  37,  38,  47,  64,  81, 100,
  109, 110, 113, 122, 140, 157, 174, 175, 178, 187
};

static short StaFin[19] =
/* finite token per state */
{
    0,   1,   2,   0,   4,   4,   4,   4,   3,   4,
    6,   0,   0,   0,   0,   0,   5,   0,   0
};

static wc_char EdgeC[187] =
/* lowest character per edge */
{ /*State*/
  /*   0 */        256,        128,        127,        126,        125,        124,         97,         96,
                    95,         93,         92,         91,         63,         62,         61,         60,
                    45,         44,         40,         39,         38,         37,         36,         35,
                    33,         32,         14,         13,         11,         10,          9,          0,
  /*   1 */          0,
  /*   2 */          0,
  /*   3 */         11,         10,          0,
  /*   4 */          0,
  /*   5 */        256,        128,        127,         32,         14,         13,         11,         10,
                     0,
  /*   6 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                     0,
  /*   7 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                     0,
  /*   8 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                    37,         36,          0,
  /*   9 */        256,        128,        127,         32,         14,         13,         11,         10,
                     0,
  /*  10 */          0,
  /*  11 */         11,         10,          0,
  /*  12 */        256,        128,        127,         32,         14,         13,         11,         10,
                     0,
  /*  13 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                    37,          0,
  /*  14 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                     0,
  /*  15 */        126,        125,        124,         97,         96,         95,         93,         92,
                    91,         63,         60,         45,         44,         40,         39,         38,
                     0,
  /*  16 */          0,
  /*  17 */         11,         10,          0,
  /*  18 */        256,        128,        127,         32,         14,         13,         11,         10,
                     0
};

static short EdgeS[187] =
/* follow (state+1) per edge */
{ /*State*/
  /*   0 */   0,   5,   0,  10,   9,   5,   9,   5,   9,   5,
              9,   5,   9,   5,  10,   5,   9,   5,   9,   5,
              9,   8,   7,   6,   5,   2,   0,   4,   0,   3,
              2,   0,
  /*   1 */   0,
  /*   2 */   0,
  /*   3 */   0,   3,   0,
  /*   4 */   0,
  /*   5 */   0,  13,   0,  13,   0,  12,   0,  11,   0,
  /*   6 */   0,   9,   0,   9,   0,   9,   0,   9,   0,   9,
              0,   9,   0,   9,   0,   9,   0,
  /*   7 */   0,  14,   0,  14,   0,  14,   0,  14,   0,  14,
              0,  14,   0,  14,   0,  14,   0,
  /*   8 */   0,   9,   0,   9,   0,   9,   0,   9,   0,   9,
              0,   9,   0,   9,   0,   9,  16,  15,   0,
  /*   9 */   0,  19,   0,  19,   0,  18,   0,  17,   0,
  /*  10 */   0,
  /*  11 */   0,  11,   0,
  /*  12 */   0,  13,   0,  13,   0,  12,   0,  11,   0,
  /*  13 */   0,  14,   0,  14,   0,  14,   0,  14,   0,  14,
              0,  14,   0,  14,   0,  14,   9,   0,
  /*  14 */   0,   9,   0,   9,   0,   9,   0,   9,   0,   9,
              0,   9,   0,   9,   0,   9,   0,
  /*  15 */   0,  14,   0,  14,   0,  14,   0,  14,   0,  14,
              0,  14,   0,  14,   0,  14,   0,
  /*  16 */   0,
  /*  17 */   0,  17,   0,
  /*  18 */   0,  19,   0,  19,   0,  18,   0,  17,   0
};

static string Tokens[7] =
/* token -> string */
{
  "[other]",
  "Space",
  "Line",
  "Name",
  "Opr",
  "Val",
  "Comment"
};

static byte Flags[7] =
/* token -> newid */
{
  0x00, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00
};

static ConcreteImp(scn_t) Scanner =
/* the scanner structure */
{
  "cprj", /* Name    */
  19,     /* States  */
   7,     /* Tokens  */
  StaEdg,
  StaFin,
  EdgeC,
  EdgeS,
  Tokens,
  Flags,
};

void Scn_get_cprj(Scn_T *scn)
/* simulates a Scn_get */
{
  *scn = Scn_copy(Scn_ADT(&Scanner));
};
