# [pim_test.cmd] command description for pim_test.c

Program pim_test -- Parser test program

doc
  <p>'pim_test' parses the given source file and lists the derivation tree on stdout.
  The source file must be conform with the language parameter. It uses the image files
  of the parser and scanner tables, [Language.lim] and [Language.pim].
  <br>
  <p>In the case you specify a start symbol the parsing process starts from this nonterminal.
  The symbol must be specified as valid start nonterminal in [Language.sty].
  If the option is omitted the parser takes the first start nonterminal.
cod

Arguments

  Language : name -- language name
  FileName : path -- path of source file to parse

Options

  Start    : string = ""    -- start symbol
  charset  : string = ""    -- source file character set ( UTF-8, UCS4, ... )
  wprint   : flag   = false -- unicode output ( on non-default character set )
  tree     : flag   = true  -- create a derivation tree ( optimized memory representation )
  xaron    : flag   = false -- create a derivation tree ( lisp like representation )
  early    : flag   = false -- use early reduction
  prepar   : string = ""    -- preprocessing: index~value , ...
  premac   : string = ""    -- preprocessing:  pre-defined macro , ...

doc
  <p>The options 'prepar' and 'premac' are only useful with styx-like preprocessing. 
  <p>If your language uses the same preprocessing directives as specified in [styx.sty], 
  but differnt macro token identifiers and keywords, the option 'prepar' can be used to 
  enable preprocessing and specify the differences as a comma separated list:
  <br>
  <ol>
  <li><b>0~name of identifier token</b>
  <li><b>1~name of macro definition token</b>
  <li><b>2~name of argument separator token</b>
  <li><b>3~name of include token</b>
  <li><b>4~name of conditional token</b>
  <li><b>5~#macro keyword</b>
  <li><b>6~#end keyword</b>
  <li><b>7~#ifdef keyword</b>
  <li><b>8~#ifndef keyword</b>
  <li><b>9~#else keyword</b>
  <li><b>10~#include keyword</b>
  <li><b>11~environment variable as search path for include files</b>
  <li><b>12~include file character set ( default: charset-option )</b>
  </ol>
  <p>The option 'premac' supports pre-defined macros in connection with 
  styx-like preprocessing.
cod

Environment

  PATH     : path -- search path for [Language.pim] and [Language.lim]
