/* ------------------------------------------------------------------------ */
/*                                                                          */
/* [stypp.c]               Pretty Printer                                   */
/*                                                                          */
/* Copyright (c) 1993 by D\olle, Manns                                      */
/* ------------------------------------------------------------------------ */

#include "stdosx.h"
#include "scn_base.h"
#include "prs.h"
#include "ptm.h"
#include "ptm_pp.h"
#include "ptm_gen.h"
#include "binimg.h"
#include "sink.h"

#include "styp_cim.h"

#define start    CTX_EVAL(string,"start")
#define srclang  CTX_EVAL(string,"srclang")
#define dstlang  CTX_EVAL(string,"dstlang")
#define filename CTX_EVAL(string,"filename")
#define xaron    CTX_EVAL(bool,"xaron")

int main(int argc, string argv[])
{ PLR_Tab PTabS, PTabD; PT_Term PTreeS, PTreeD;
  Scn_T Scn; Scn_Stream cStream; PT_Cfg PCfg;
  CTX_init_stypp(argc,argv);
  initSymbols();
  PTabS = PLR_getTab(srclang);
  PTabD = PLR_getTab(dstlang);
  Scn_get(srclang,&Scn);
  cStream = Stream_file(Scn,"",filename,"");
  PCfg  = PT_init(PTabS,cStream);
  if( ! xaron ) PTreeS = PT_PARSE(PCfg,start);
  else          PTreeS = XPT_PARSE(PCfg,start);
  PT_setErrorCnt(PT_synErrorCnt(PCfg));
  PT_quit(PCfg);
  Stream_close(cStream);
  Stream_free(cStream);
  Scn_free(Scn);
  if( PT_errorCnt() == 0 )
  {
    PTP_init(PTabD);
    PTreeD = PTP_transform(PTreeS);
    PTP_pp(PTreeD,STDOUT);
    PTP_quit();
    PT_delT(PTreeD);
  }
  PT_delT(PTreeS);
  PLR_delTab(PTabD);
  PLR_delTab(PTabS);
  freeSymbols();
  CTX_quit();
  BUG_CORE;
  return(0);
}
